<template>
  <v-app id="inspire-login" class="w-100 ">
    <v-main>
      <v-container
        class="fill-height"
        fluid
      >
        <v-row
          align="center"
          justify="center"
        >
          <v-col
            cols="12"
            sm="8"
            md="4"
          >

              <v-img
            src="/img/logo.jpeg"
            lazy-src="/img/logo.jpeg"
            aspect-ratio="3"
            max-width="475"
            max-height="171"
            ></v-img>
            <v-card class="elevation-12">
              <v-toolbar
                color="primary"
                dark
                flat
              >
                <v-toolbar-title>Connexion</v-toolbar-title>
                <v-spacer></v-spacer>
                <v-tooltip bottom>
                  <template v-slot:activator="{ on }">
                    <v-btn
                      @click="login"
                      icon
                      large
                      target="_blank"
                      v-on="on"
                    >
                      <v-icon>mdi-code-tags</v-icon>
                    </v-btn>
                  </template>
                  <span>Source</span>
                </v-tooltip>
              </v-toolbar>
              <v-card-text>
                <ValidationObserver class="w-100" ref="form" v-slot="{ invalid  }">
                 <ValidationProvider :custom-messages="errorMessages.email" v-slot="{ errors }" name="email" rules="required|email">
                  <v-text-field
                    label="E-mail"
                    name="email"
                    :error-messages="errors"
                    prepend-icon="mdi-account"
                    type="text"
                    v-model="details.email"
                  ></v-text-field>
                </ValidationProvider>
                <ValidationProvider :custom-messages="errorMessages.password" v-slot="{ errors }" name="password" rules="required">
                  <v-text-field
                    id="password"
                    v-model="details.password"
                    label="Mot de passe"
                    name="password"
                    :error-messages="errors"
                    prepend-icon="mdi-lock"
                    type="password"
                  ></v-text-field>
                  </ValidationProvider>
                </ValidationObserver>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="primary" @click="login">Se connecter</v-btn>
              </v-card-actions>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </v-main>
  </v-app>
</template>

<script>
import { mapGetters, mapActions } from "vuex";
import * as rules from 'vee-validate/dist/rules'
import { extend, ValidationProvider, ValidationObserver } from "vee-validate";

Object.keys(rules).forEach(rule => {
  extend(rule, rules[rule]);
});

  extend('required', {
    ...rules['required'],
    message: '{_field_} can not be empty',
  })
  extend('date_gtt', value => 
  {
    //on recupere la date
    var current = moment()

    var d = moment(value)

    var diff = current.diff(d)
    //on verifie que la date n'est pas anterieure à la date courante
    return diff > 0

});
  extend('date', value => 
  {
    var dateReg = /^\d{4}([-])\d{2}([-])\d{2}$/
    //on recupere la date

    //on verifie que la date n'est pas anterieure à la date courante
    return  value.match(dateReg)

});
export default {
  name: "Home",
  data: function() {
    return {
      details: {
        email:"admin@bioclin.com",
        password:"password"
      },
                            errorMessages:
                  {
                    email : 
                    {
                      required: "L'e-mail est requis",
                      email: "L'e-mail a un format invalide",

                    },
                    password:
                    {
                      required:'Le mot de passe est requis'
                    }
                  }
    };
  },
  computed: {
    ...mapGetters(["auth/isLoggedIn"])
  },
  mounted() {
    //this.$store.commit("setErrors", {});
  },
  methods: {
    ...mapActions({sendLoginRequest:"auth/sendLoginRequest"}),
    login: function() 
    {
      this.sendLoginRequest(this.details).then(() => {
      this.$router.push({ name: "dashboard" });
      },
      (error) => 
      {
        if(this.$refs.form)
        {
          console.log(this.$refs.form)
          this.$refs.form.setErrors(error.response.data.errors)
        }
      });
    }
  },
          components: {
      ValidationProvider,
      ValidationObserver,
    },
};
</script>